hdoj 4790 Just Random 【数学】

题目:hdoj 4790 Just Random

题意:给你两个闭区间【a,b】,【c,d】,分别从中等可能的跳出 x 和 y ,求(x+y)%p == m的概率

分析:

假如是【3,5】 【4,7】   p = 2 , m = 1;

则所有的和

7 8
9 10

8 9
10 11

9 10
11 12

1 2
3 3 2
1

后面一行出现次数,可以发现可以分成三部分,第一部分递增的等差数列,第二部分值都相等,第三部分等差数列

然后用等差数列求和公式求和就ok

AC代码:

#include<iostream>
#include<stdio.h>
#include<string.h>
#include<algorithm>
#include<queue>
#include<stack>
#define MAXN 100005
using namespace std;
typedef long long LL;
LL p,m;
LL gcd(LL a,LL b)
{
    if(b==0)
        return a;
    return gcd(b,a%b);
}
int main()
{
    //freopen("Input.txt","r",stdin);
    int T;
    scanf("%d",&T);
    for(int cas = 1; cas<=T; cas++)
    {
        LL a,b,c,d,ans = 0;
        scanf("%I64d%I64d%I64d%I64d%I64d%I64d",&a,&b,&c,&d,&p,&m);
        if((b-a)>(d-c))
            swap(a,c),swap(b,d);
        long long t1 = (a+c)%p;
        long long add = (m - t1 + p)%p;
        long long cnt1 = (a+c + add-m)/p;
        long long t2 = (b+c-1)%p;
        long long sub = (t2 - m + p)%p;
        long long cnt2 = (b+c-1-sub-m)/p;
        //cout<<t2<<" "<<sub<<endl;
        ans += (cnt2 - cnt1 + 1)*(1+add) + (cnt2 - cnt1 + 1)*(cnt2 - cnt1)/2 * p;
        t1 = (b+c)%p;
        add = (m - t1 + p)%p;
        cnt1 = (b+c+add-m)/p;
        t2 = (a+d)%p;
        sub = (t2 - m + p)%p;
        cnt2 = (a+d-sub-m)/p;
        ans += (cnt2 - cnt1 + 1)*(b-a+1);
        t1 = (a+d+1)%p;
        add = (m - t1 + p)%p;
        cnt1 = (a+d+1+add-m)/p;
        t2 = (b+d)%p;
        sub = (t2 - m + p)%p;
        cnt2 = (b+d-sub-m)/p;
        ans += (cnt2 - cnt1 + 1)*(1+sub) + (cnt2 - cnt1 + 1)*(cnt2 - cnt1)/2*p;
        long long tot = (b-a+1)*(d-c+1);
        long long GCD = gcd(ans,tot);
        ans /= GCD;
        tot /= GCD;
        printf("Case #%d: %I64d/%I64d\n",cas,ans,tot);
    }
    return 0;
}
时间: 2024-10-04 11:53:23

hdoj 4790 Just Random 【数学】的相关文章

HDU 4790 Just Random 数学

链接:pid=4790">http://acm.hdu.edu.cn/showproblem.php?pid=4790 意:从[a.b]中随机找出一个数字x,从[c.d]中随机找出一个数字y.给出p.m,假设(x+y)%p==m则算成功,问成功的概率是多少. 思路:[a.b]中连续p个数.[c,d]中连续p个数.用这2*p个数进行组合能找到p种的成功组合(详细不证),所以找到[a.b]中p循环的个数x1,[c,d]中p循环的个数y1,则它们组成的成功组合数为p*x1*y1. 然后是处理边界

hdu 4790 Just Random 神奇的容斥原理

1 /** 2 大意: 给定[a,b],[c,d] 在这两个区间内分别取一个x,y 使得 (x+y)%p = m 3 思路:res = f(b,d) -f(b,c-1)-f(a-1,d)+f(a-1,c-1); f(b,d ) 表示在[0,b],[0,d] 之间有多少个符合上述要求的数 4 1.将[0,b] 分为两部分, b/p 和 b%p 能整除p的[0,(b/p)*p] 和[(b/p)*p+1,b ] 同理[0,d]也可以这样分, 这样对于[0,b] [0,d ] 分别有两种情况,则一共有四

HDU - 4790 Just Random

题意:求从[a,b],[c,d]两个区间找到两个数使得他们的和%p=m,求概率 思路:我们想办法把区间的左范围化到0,那么结果就相对好弄了,应用容斥原理比直接解答问题简单点,假设f(a,b)是区间[0,a],[0,b]中满足条件的个数,设p=6.m=2 那么第一个区间可以看成 : A=[0,1,2,3,4,5]+[0,1,2,3,4,5]+..... B= (0,1,2,3,4) 第二个区间可以看成:C=[0,1,2,3,4,5]+....D=(0,1) 那么题目就可以看成:A+C,A+D, B

HDU 4790 Just Random 【构造】

题目链接:传送门 题目大意:给你a, b, c, d, p and m(0 <= a <= b <= 109, 0 <=c <= d <= 109, 0 <= m < p <= 109).让你从 [a, b] 中取出一个x,从[c, d] 中取出一个y,使得(x+y)(mod p)=m,求一共有多少种可能. 看见题目就想到了用构造的想法,讲解构造成二维坐标系,x+y=k*p+m是一条线,求这条线与构造的矩形(由点组成)一共有几个交点,这个矩阵也是有一定

hdu 4790 Just Random 容斥原理+数学

Just Random Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others) Total Submission(s): 1723    Accepted Submission(s): 483 Problem Description Coach Pang and Uncle Yang both love numbers. Every morning they play a game w

hdu 4790 Just Random (2013成都J题) 数学思路题 容斥

题意:在[a,b]  [c,d] 之间,和模p等于m的对数 详见代码 1 #include <stdio.h> 2 #include <algorithm> 3 #include <string.h> 4 #include<cmath> 5 #define LL long long 6 using namespace std; 7 int T; 8 LL a,b,c,d,p,m; 9 10 LL gcd(LL a, LL b) { 11 return b ?

hdu 4790 Just Random (思路+分类计算+数学)

Problem Description Coach Pang and Uncle Yang both love numbers. Every morning they play a game with number together. In each game the following will be done: 1. Coach Pang randomly choose a integer x in [a, b] with equal probability. 2. Uncle Yang r

【HDOJ】4579 Random Walk

1. 题目描述一个人沿着一条长度为n个链行走,给出了每秒钟由i到j的概率($i,j \in [1,n]$).求从1开始走到n个时间的期望. 2. 基本思路显然是个DP.公式推导也相当容易.不妨设$dp[i], i \in [1,n]$表示由i到n的期望时间.\begin{align}    dp[i] &= \Sigma_{j=1}^{n} p(i, j) (dp[j] + 1),    &j<n\\    dp[i] &= 0 &i=n\end{align}显然这是

hdu - 4790 - Just Random(容斥 + 组合数学)

题意:在 [a, b] 取一个整数 x,在 [c, d] 取一个整数 y,求满足 (x + y) % p = m 的 (x, y) 的对数(0 <= a <= b <= 10 ^ 9, 0 <=c <= d <= 10 ^ 9, 0 <= m < p <= 10 ^ 9). 题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4790 -->>2013年成都区赛最后一题,当时TLE6次无果....加